Package: org.apache.groovy.groovysh

## [Groovy] Class Shell

- org.apache.groovy.groovysh.Shell

-     class Shell
      extends Object

  A simple shell for invoking commands from a command-line.

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `protected Logger` | `log` |

  - ### Properties Summary

    Properties
    Type | Name and description
    --- | ---
    `private IO` | `io`
    `private CommandRegistry` | `registry`

  - ### Constructor Summary

    Constructors
    Constructor and description
    `Shell (IO io)`
    `Shell ()`
    `Shell ()`

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `Object` | `execute(String line)`
    `` | `Command` | `findCommand(String line, List<String> parsedArgs)` Parameters: `line` - the line to parse
    `` | `boolean` | `isExecutable(String line)`
    `` | `Object` | `leftShift(String line)` this should probably be deprecated
    `` | `Command` | `leftShift(Command command)`
    `` | `Command` | `register(Command command)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Object` | `wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`

- - ### Field Detail

    - #### protected final Logger log

  - ### Property Detail

    - #### private final IO io

    - #### private final CommandRegistry registry

  - ### Constructor Detail

    - #### Shell(IO io)

    - #### Shell()

  - ### Method Detail

    - #### Object execute(String line)

    - #### Command findCommand(String line, List<String> parsedArgs)

      Parameters:
        `line` - the line to parse
        `parsedArgs` - accumulate the rest of the line after the command

    - #### boolean isExecutable(String line)

    - #### Object leftShift(String line)

      this should probably be deprecated

    - #### Command leftShift(Command command)

    - #### Command register(Command command)